// You can import API functions like this from D3.js.
import { select } from 'd3';

// You can import local modules like this. See message.js!
import { message } from './myMessage';



import {cars, formatCarsInfo} from './cars';

const test_msg = cars.filter(car => car.price < 2000).map(formatCarsInfo).join(';');
// const prices = cars.map(car => car.price);

// This line uses D3 to set the text of   the message div.
select('#content').text(`${test_msg}`);

const canvasWidth = +select('#canvas').attr('width');
const canvasHeight = +select('#canvas').attr('height');


const gUpdate = select('#canvas')
		.selectAll('g')
		.data([null])
		;

const gEnter = gUpdate
		.enter()
		.append('g');

const rectMinSize = 100;
let num = 0;
const maxNum = canvasWidth / rectMinSize;
while (num < maxNum) {
  // Render a rectangle SVG in diagonal
  gEnter
    .append('rect')
		.attr('x', 0 + rectMinSize * num + 10)
		.attr('y', 0 + rectMinSize * num + 10)
    .attr('width', rectMinSize - 20)
    .attr('height', rectMinSize - 20)
    .attr('fill', 'blue')
  	.attr('stroke', 'red')
		;

  // FOR EACH COLUMN (i), ADD RECTS BELOW DIAGONAL LINE
  // row-index: i, column-index: j
  for (let i = num; i < maxNum - 1; i++) {
    for (let j = i + 1; j < maxNum; j++) {
      
      gEnter
        .append('rect')
        .attr('x', 0 + rectMinSize * i + 10)
        .attr('y', 0 + rectMinSize * j + 10)
        .attr('width', rectMinSize - 20)
        .attr('height', rectMinSize - 20)
        .attr('fill', 'green')
        .attr('stroke', 'red')
        ;
    }
  }
  // FOR EACH ROW, ADD RECTS RIGHT OF DIAGONAL LINE
  for (let j = num; j < maxNum - 1; j++) {
    for (let i = j + 1; i < maxNum; i++) {
      
      gEnter
        .append('rect')
        .attr('x', 0 + rectMinSize * i + 10)
        .attr('y', 0 + rectMinSize * j + 10)
        .attr('width', rectMinSize - 20)
        .attr('height', rectMinSize - 20)
        .attr('fill', 'yellow')
        .attr('stroke', 'red')
        ;
    }
  }
  // Increase counter by 1
  num += 1;
}

// // Add first rectangle
// const gRectEnter = gEnter
//     .append('rect')
// 		.attr('x', 0)
// 		.attr('y', 0)
//     .attr('width', 100)
//     .attr('height', 100)
//     .attr('fill', 'yellow')
// 		;
// // Add second rectangle
// const gRect2Enter = gEnter
//     .append('rect')
// 		.attr('x', 100)
// 		.attr('y', 100)
//     .attr('width', 100)
//     .attr('height', 100)
//     .attr('fill', 'red');
// Add first horizontal line
const gLineEnter = gEnter
		.append('line')
    // .attr('class', 'selected-yellow-line')
    .attr('x1', 0)
    .attr('y1', 0)
    .attr('x2', 500)
    .attr('y2', 0);
// Add second verticle line
const gLine2Enter = gEnter
		.append('line')
    // .attr('class', 'selected-yellow-line')
    .attr('x1', 0)
    .attr('y1', 500)
    .attr('x2', 0)
    .attr('y2', 0);
// Add third line
const gDiagnoalLine3Enter = gEnter
		.append('line')
    // .attr('class', 'selected-pink-line')
    .attr('x1', 0)
    .attr('y1', 0)
    .attr('x2', 500)
    .attr('y2', 500);



// WORKS
select('#content2')
.selectAll('ol')
.data(cars)
.enter()
.append('li')
.text(d => d.make);